#ifndef _EHMOUSE_H_
#define _EHMOUSE_H_

/** @file
 *  @brief This file is Definition of Class EMouse.
 */
#include "EasyDeviceImpl.h"
#include "ObjectManipulator.h"

class EMouse : public EasyDevice::Impl
{
private:
	BVector3 center_;
	BVector3 origin_;
	BVector3 scale_;

  	BQuaternion orientation_;
	BQuaternion orientation0_;
    BQuaternion centerOrientation_;
    BQuaternion centerOrientation0_;	

	BVector3 position_;
	BVector3 position0_;

    BEnum initFlag_;
 
	void Convert(BVector3&t)
	{
	t.x=origin_.x+t.x*scale_.x;
	t.y=origin_.y+t.y*scale_.y;
	t.z=origin_.z+t.z*scale_.z;
	}
    void ConvertR(BVector3&t,const BVector3&u)
    {
	t.x=(u.x-origin_.x)/scale_.x+center_.x;
	t.y=(u.y-origin_.y)/scale_.y+center_.y;
	t.z=(u.z-origin_.z)/scale_.z+center_.z;
    }

	ObjectManipulator	objectManipulator;
	void _GetOrientation(BQuaternion&q);
	void _GetOrientation(BQuaternion&q, BQuaternion&c0);

public:
	EMouse();
	~EMouse();

	void MouseFunction(int button,int state, int x, int y);
	void MotionFunction(int x, int y);
	void ReshapeFunction(int w, int h);

	void CallBackHpFunction(void);
	void Enter(void);
	void Leave(void);

    void SetScale(BReal s);
	void SetOrientation(const BQuaternion&orientation);

	void GetPosition(BVector3&position);
	void GetOrientation(BQuaternion&orientation);
	void GetLastPosition(BVector3&p)const{p=position_;}
	void GetLastOrientation(BQuaternion&q)const{q=orientation_;}

	bool Initialize(void);
	bool Stop(void);

	void SetCallBackHpFunction(void(*hp)(void));
	void SetCallBackStFunction(void(*st)(void));
	void SetCallBackKbFunction(void(*kb)(unsigned char), unsigned char key); 
};

#endif