#ifndef _EASYDEVICEIMPL_H_
#define _EASYDEVICEIMPL_H_

/** @file
 *  @brief This file is Definition of Class EasyDevice::Impl.
 *
 *  This is used for internal implimentation .
 */
#include "EasyDevice.h"
#include "BasicTypes.h"

#define HAPTICS_BUTTON_DOWN 1
#define HAPTICS_BUTTON_UP   2
#define HAPTICS_BUTTON_ON   3
#define HAPTICS_BUTTON_OFF  0

class EasyDevice::Impl
{
protected:
	void(*callBackHpFunction)(void);
	void(*callBackStFunction)(void);
	void(*callBackKbFunction)(unsigned char);
	unsigned char key_;

public:
	Impl();
	~Impl();

	bool Start(void){return Initialize();}

	virtual	void SetForce(BVector3&t);
	virtual	void SetTorque(BVector3&t);
	virtual	int  GetButton(int n);
	virtual	void WaitForUserAdmit();

	//mouse function
	virtual	void MouseFunction(int button,int state, int x, int y);
	virtual	void MotionFunction(int x, int y);
	virtual	void ReshapeFunction(int w, int h);

	virtual	void SetScale(BReal s)=0;
	virtual	void SetOrientation(const BQuaternion&orientation)=0;
	
	virtual	void GetPosition(BVector3&position)=0;
	virtual	void GetOrientation(BQuaternion&orientation)=0;
	virtual	void GetLastPosition(BVector3&p) const=0;
	virtual	void GetLastOrientation(BQuaternion&q) const=0;

	virtual	bool Initialize(void)=0;
	virtual	bool Stop(void)=0;

	virtual	void SetCallBackHpFunction(void(*hp)(void))=0;
	virtual	void SetCallBackStFunction(void(*st)(void))=0;
	virtual	void SetCallBackKbFunction(void(*kb)(unsigned char), unsigned char key)=0; 
};
#endif